import type { AstroConfig } from '../@types/astro-core';
import type { AstroDevServer } from './dev';
import type { LogOptions } from './logger';
import vite from './vite.js';
declare type ViteConfigWithSSR = vite.InlineConfig & {
    ssr?: {
        external?: string[];
        noExternal?: string[];
    };
};
interface CreateViteOptions {
    astroConfig: AstroConfig;
    devServer?: AstroDevServer;
    logging: LogOptions;
}
/** Return a common starting point for all Vite actions */
export declare function createVite(inlineConfig: ViteConfigWithSSR, { astroConfig, logging, devServer }: CreateViteOptions): Promise<ViteConfigWithSSR>;
export {};
